<?php include_once 'codebase/hyperframe.php' ?><h1>Pages in Subdirectories</h1>

<h3>and issues met on larger sites with segregated content</h3>

<p><strong>The default Hyperframe installation expects all webpages to be in a single directory, the site root. This is probably the most convenient arrangement for small sites of up to, say, fifty pages, and is typical of most flatfile CMS packages. Hyperframe is however capable of supporting tree-structured sites. For larger sites it will be more convenient to segregate content into site sections, each section consisting of a subdirectory with its own html files and associated images. </strong></p>

<p>The main change needed is to use an absolute filesystem path for references to codebase/hyperframe.php, the system loader, such that it can be loaded regardless of the page&#39;s location.</p>

<ul>
  <li>If your php subsystem is of the Apache module, this reference will be in <em>.htaccess</em></li>
  <li>If your php subsystem is of the CGI or FastCGI type, this reference will be in <em>either</em>&nbsp;php.ini <em>or</em> .user.ini&nbsp;</li>
</ul>

<h3>Apache module mode:</h3>

<p>In .htaccess, the line in question is:<br />
&nbsp; <strong>php_value auto_prepend_file codebase/hyperframe.php</strong></p>

<p>and you need to prefix this with the filesystem root of your site. The filesystem root varies from host to host, but will be something like &#39;/home/[username]/public_html/&#39; You can generally find out what this value is from your host&#39;s documentation or online resources. So, you adjust this line to :<br />
<strong>&nbsp; php_value auto_prepend_file /home/widgetsinc/public_html/codebase/hyperframe.php</strong></p>

<p>Since .htaccess directives apply to subdirectories there is no need to repeat this elsewhere.</p>

<h3>CGI mode:</h3>

<p>Here the setting is in a php.ini or .user.ini file in the root of the website. (note the dot before .user.ini, this is not a typo)</p>

<p>Which of the two will apply is sometimes hard to determine, and the best answer here is to consult your host&#39;s documentation. You can in fact have both, as the redundant file will will not cause any errors.</p>

<p>The main difference between them is that php.ini does not apply to subdirectories, so on servers controlled by a php.ini config, you need to place a copy of your php.ini inside <em>all</em> directories containing html pages.</p>

<p>.user.ini applies to the current level <em>and all sublevels</em> so you only need one declaration in the site root. Conversely, you will need a .user.ini <em>cancelling </em>the prepend in any subdirectories where you do <em>not</em> wish the CMS to process content.</p>

<p>For example, if your site root is &#39;/home/widgetsinc/public_html/&#39; then<strong> </strong>the line to activate the CMS might read:</p>

<p style="margin-left: 40px;">auto_prepend_file = &#39;<strong>/home/widgetsinc/public_html/</strong>codebase/hyperframe.php&#39;</p>

<p>The cancellation command reads: auto_prepend_file = &#39;<strong>none</strong>&#39;</p>

<p>BTW if the system cannot find hyperframe.php, it will let you know about this, in no uncertain terms. In that case, you need to check that you have given&nbsp;the right location.</p>

<p>We are looking at writing an installer to automate this task, however there are difficulties with determining which architecture exists on any given webhost.</p>

<h3>Good Practices</h3>

<p>In sites with subdirectories, it is always best to refer to images and links by way of a relative path. If you use absolute paths, you will create a &#39;nailed-down&#39; website which cannot be moved to another directory. This is not generally an issue when linking to content in the same or lower directory, but issues may arise when linking upward in the path, or across to other branches. In that case, check your link syntax carefully.</p>
